describe("Curso", function() {

  var curso = new Curso();


  describe("Al crear una nueva instancia", function () {
    it("El nombre no está definido", function() {
      expect(curso.nombre).toBeUndefined();
    });      
    
    it("La fecha de inicio no está definida", function() {
      expect(curso.inicio).toBeUndefined();
    });
    
    it("La fecha de término no está definida", function() {
      expect(curso.termino).toBeUndefined();
    });
    
    it("La duración no está definida", function() {
      var duracion = curso.duracion();
      expect(duracion).toBeUndefined();
    });
  });

    describe("Al asignarle valores a la instancia", function () {
      
      beforeEach(function () {
        curso.nombre = "JavaScript";
        // Los meses van de 0 Enero al 11 Diciembre
        curso.inicio = new Date(2014, 0, 1);
        curso.termino = new Date(2014, 0, 11);        
      });
      
      
      it("Tiene nombre asignado", function() {
        expect(curso.nombre).toBeDefined();
        expect(curso.nombre).toBe("JavaScript");        
      });      
    
      /*
      + delante de una fecha convierte el valor a milisegundos.
      La fecha está en formato Epoch y comienza el 1 de enero de 1970 a las 00:00:00
      
      http://www.epochconverter.com/

      var fecha = new Date(1969, 11, 31, 18, 0 ,0);

      -> Wed Dec 31 1969 18:00:00 GMT-0600 (CST)

      Si al obtener una fecha se obtiene una zona horaria se ajustan los milisegundos. 
      
      +fecha
      
      */
    
      it("Tiene fecha de inicio asignada", function() {
        var fecha = new Date(2014, 0, 1);
        expect(curso.inicio).toBeDefined();
        expect(+curso.inicio).toBe(+fecha);                
      });
    
      it("Tiene fecha de término asignada", function() {
        var fecha = new Date(2014, 0, 11);
        expect(curso.termino).toBeDefined();
        expect(+curso.termino).toBe(+fecha);
      });
    
      it("Tiene duración asignada", function() {
        var duracion = curso.duracion();
        expect(duracion).toBeDefined();        
        expect(duracion).toBe("10 dias");
      });
    
  });

});
